/* $NetBSD$ */

/*-
 * Copyright (c)2006, 2012 Takehiko NOZAKI,
 * All rights reserved.
 *
 * Redistribution and use in source and binary forms, with or without
 * modification, are permitted provided that the following conditions
 * are met:
 * 1. Redistributions of source code must retain the above copyright
 *    notice, this list of conditions and the following disclaimer.
 * 2. Redistributions in binary form must reproduce the above copyright
 *    notice, this list of conditions and the following disclaimer in the
 *    documentation and/or other materials provided with the distribution.
 *
 * THIS SOFTWARE IS PROVIDED BY THE AUTHOR AND CONTRIBUTORS ``AS IS'' AND
 * ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE
 * IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE
 * ARE DISCLAIMED.  IN NO EVENT SHALL THE AUTHOR OR CONTRIBUTORS BE LIABLE
 * FOR ANY DIRECT, INDIRECT, INCIDENTAL, SPECIAL, EXEMPLARY, OR CONSEQUENTIAL
 * DAMAGES (INCLUDING, BUT NOT LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS
 * OR SERVICES; LOSS OF USE, DATA, OR PROFITS; OR BUSINESS INTERRUPTION)
 * HOWEVER CAUSED AND ON ANY THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT
 * LIABILITY, OR TORT (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY
 * OUT OF THE USE OF THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF
 * SUCH DAMAGE.
 *
 */

#ifndef _TR24731_H_
#define	_TR24731_H_

#ifndef __STDC_WANT_LIB_EXT1__
#define __STDC_WANT_LIB_EXT1__	1
#endif

#if 1
#if defined(__STDC_WANT_LIB_EXT1__)

/*
 * errno.h stuff
 */
#include <errno.h>
#define _BSD_ERRNO_T_	int

#ifdef  _BSD_ERRNO_T_
typedef _BSD_ERRNO_T_	errno_t;
#undef  _BSD_ERRNO_T_
#endif

/*
 * stddef.h stuff
 */
#include <stddef.h>
#define _BSD_RSIZE_T_	size_t

#ifdef  _BSD_RSIZE_T_
typedef _BSD_RSIZE_T_	rsize_t;
#undef  _BSD_RSIZE_T_
#endif

/*
 * stdint.h stuff
 */
#include <stdint.h>
#define RSIZE_MAX	SIZE_MAX

/*
 * stdio.h stuff
 */
#include <stdio.h>
__BEGIN_DECLS
errno_t	fopen_s(FILE * __restrict * __restrict,
	    const char * __restrict, const char * __restrict);
errno_t	freopen_s(FILE * __restrict * __restrict,
	    const char * __restrict, const char * __restrict,
	    FILE * __restrict);
char	*gets_s(char *, rsize_t);
__END_DECLS

/*
 * stdlib.h stuff
 */
#include <stdlib.h>

typedef void (*constraint_handler_t)
	(const char * __restrict, void * __restrict, errno_t);

__BEGIN_DECLS
constraint_handler_t set_constraint_handler_s(constraint_handler_t);
void	abort_handler_s(const char * __restrict, void * __restricr, errno_t);
void	ignore_handler_s(const char * __restrict, void * __restrict, errno_t);
void	strict_handler_s(const char * __restrict, void * __restrict, errno_t);
void*	bsearch_s(const void *, const void *, rsize_t, rsize_t,
	    int (*)(const void *, const void *, void *), void *);
errno_t	getenv_s(size_t * __restrict, char * __restrict, rsize_t,
	    const char * __restrict);
errno_t	qsort_s(void *, rsize_t, rsize_t,
	    int (*)(const void *, const void *, void *), void *);
__END_DECLS

/*
 * string.h stuff
 */
#include <string.h>

__BEGIN_DECLS
errno_t	memcpy_s(void * __restrict, rsize_t, const void * __restrict, rsize_t);
errno_t	memmove_s(void *, rsize_t, const void *, rsize_t);
errno_t	strcat_s(char * __restrict, rsize_t, const char * __restrict);
errno_t	strcpy_s(char * __restrict, rsize_t, const char * __restrict);
errno_t	strncat_s(char * __restrict, rsize_t, const char * __restrict, rsize_t);
errno_t	strncpy_s(char * __restrict, rsize_t, const char * __restrict, rsize_t);
size_t	strnlen_s(const char *, size_t);
char*	strtok_s(char * __restrict, rsize_t * __restrict,
	    const char * __restrict, char ** __restrict);
errno_t	strerror_s(char *, rsize_t, errno_t);
size_t	strerrorlen_s(errno_t);
__END_DECLS

/*
 * wchar.h stuff
 */
#include <wchar.h>

__BEGIN_DECLS
errno_t	wmemcpy_s(void * __restrict, rsize_t, const void * __restrict, rsize_t);
errno_t	wmemmove_s(void *, rsize_t, const void *, rsize_t);
errno_t	wcscat_s(wchar_t * __restrict, rsize_t, const wchar_t * __restrict);
errno_t	wcscpy_s(wchar_t * __restrict, rsize_t, const wchar_t * __restrict);
errno_t	wcsncat_s(wchar_t * __restrict, rsize_t,
	    const wchar_t * __restrict, rsize_t);
errno_t	wcsncpy_s(wchar_t * __restrict, rsize_t,
	    const wchar_t * __restrict, rsize_t);
size_t	wcsnlen_s(const wchar_t *, size_t);
wchar_t* wcstok_s(wchar_t * __restrict, rsize_t * __restrict,
	    const wchar_t * __restrict, wchar_t ** __restrict);
__END_DECLS

#endif /*__STDC_WANT_LIB_EXT1__ */
#endif

#endif /*_TR24731_H_*/
