/* $NetBSD$ */

/*-
 * Copyright (c)2006, 2012 Takehiko NOZAKI,
 * All rights reserved.
 *
 * Redistribution and use in source and binary forms, with or without
 * modification, are permitted provided that the following conditions
 * are met:
 * 1. Redistributions of source code must retain the above copyright
 *    notice, this list of conditions and the following disclaimer.
 * 2. Redistributions in binary form must reproduce the above copyright
 *    notice, this list of conditions and the following disclaimer in the
 *    documentation and/or other materials provided with the distribution.
 *
 * THIS SOFTWARE IS PROVIDED BY THE AUTHOR AND CONTRIBUTORS ``AS IS'' AND
 * ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE
 * IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE
 * ARE DISCLAIMED.  IN NO EVENT SHALL THE AUTHOR OR CONTRIBUTORS BE LIABLE
 * FOR ANY DIRECT, INDIRECT, INCIDENTAL, SPECIAL, EXEMPLARY, OR CONSEQUENTIAL
 * DAMAGES (INCLUDING, BUT NOT LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS
 * OR SERVICES; LOSS OF USE, DATA, OR PROFITS; OR BUSINESS INTERRUPTION)
 * HOWEVER CAUSED AND ON ANY THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT
 * LIABILITY, OR TORT (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY
 * OUT OF THE USE OF THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF
 * SUCH DAMAGE.
 *
 */

#ifndef _GETS_S_TEMPLATE_H_
#define _GETS_S_TEMPLATE_H_

#include "tr24731_local.h"
#define fail(err, ...) \
do { \
	for (;;) { \
		ch = _FGETC_UNLOCKED(fp); \
		if (_FERROR(fp) != 0) \
			break; \
		if (_FEOF(fp) != 0) \
			break; \
		if (ch == _L('\n')) \
			break; \
	} \
	FUNLOCKFILE(fp); \
	(void)__runtime_error(err, __func__, __VA_ARGS__); \
	if (writable != 0) \
		*s = _L('\0'); \
	return NULL; \
	/* NOTREACHED */ \
} while (/*CONSTCOND*/0)
#include "tr24731_constraint.h"

_CHAR_TYPE *
_FUNCNAME(_CHAR_TYPE *s, rsize_t n)
{
	FILE *fp;
	_CHAR_TYPE *p;
	_INT_TYPE ch;
	int writable;

	fp = stdin;

	FLOCKFILE(fp);
	_ORIENTATION(fp);

	writable = 0;
	assert_not_null(s);
	assert_rsize_max(n);
	assert_not_zero(n);
	writable = 1;

	p = s;
	while (n-- > 0) {
		ch = _FGETC_UNLOCKED(fp);
		if (_FERROR(fp) != 0) {
			p = s;
			s = NULL;
			goto done;
		}
		if (_FEOF(fp) != 0) {
			if (p == s)
				s = NULL;
			goto done;
		}
		if (ch == _L('\n'))
			goto done;
		*p++ = (_CHAR_TYPE)ch;
	}
	fail(CONSTRAINT_NOT_FOUND_NEWLINE, "n-1");

done:
	FUNLOCKFILE(fp);
	*p = _L('\0');
	return s;
}
#endif /*_GETS_S_TEMPLATE_H_*/
