/* $NetBSD$ */

/*-
 * Copyright (c)2006, 2012 Takehiko NOZAKI,
 * All rights reserved.
 *
 * Redistribution and use in source and binary forms, with or without
 * modification, are permitted provided that the following conditions
 * are met:
 * 1. Redistributions of source code must retain the above copyright
 *    notice, this list of conditions and the following disclaimer.
 * 2. Redistributions in binary form must reproduce the above copyright
 *    notice, this list of conditions and the following disclaimer in the
 *    documentation and/or other materials provided with the distribution.
 *
 * THIS SOFTWARE IS PROVIDED BY THE AUTHOR AND CONTRIBUTORS ``AS IS'' AND
 * ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE
 * IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE
 * ARE DISCLAIMED.  IN NO EVENT SHALL THE AUTHOR OR CONTRIBUTORS BE LIABLE
 * FOR ANY DIRECT, INDIRECT, INCIDENTAL, SPECIAL, EXEMPLARY, OR CONSEQUENTIAL
 * DAMAGES (INCLUDING, BUT NOT LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS
 * OR SERVICES; LOSS OF USE, DATA, OR PROFITS; OR BUSINESS INTERRUPTION)
 * HOWEVER CAUSED AND ON ANY THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT
 * LIABILITY, OR TORT (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY
 * OUT OF THE USE OF THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF
 * SUCH DAMAGE.
 *
 */

#ifndef _MEMCPY_S_TEMPLATE_H_
#define	_MEMCPY_S_TEMPLATE_H_

#include "tr24731_local.h"
#define fail(err, ...) \
do { \
	if (writable != 0) { \
		s = (_CHAR_TYPE *)s1; \
		*s = (_CHAR_TYPE)0; \
	} \
	return __runtime_error(err, __func__, __VA_ARGS__); \
	/*NOTREACHED*/ \
} while (/*CONSTCOND*/0)
#include "tr24731_constraint.h"

errno_t
_FUNCNAME(void * __restrict s1, rsize_t s1max,
	const void * __restrict s2, rsize_t n)
{
	_CHAR_TYPE *s;
	int writable;

	writable = 0;
	assert_not_null(s1);
	assert_rsize_max(s1max);
	writable = (s1max > (rsize_t)0);

	assert_not_null(s2);
	assert_not_overlap(s1, s2, _CHAR_TYPE, s1max);
	assert_rsize_max(n);
	assert_not_gt(n, s1max);

	if (n > (rsize_t)0)
		_MEMCPY_FUNC(s1, s2, (size_t)n);

	return (errno_t)0;
}
#endif /*_MEMCPY_S_TEMPLATE_H_*/
