/* $NetBSD$ */

#include <assert.h>
#include <stddef.h>
#include <stdint.h>
#include <stdlib.h>
#include <string.h>
#if 0
#include <wchar.h>
#else
#include <tr24731.h>
#endif

void test_n1135(void);

void
test_n1135(void)
{
	static char str1[] = "?a???b,,,#c";
	static char str2[] = "\t \t";
	char *t, *ptr1, *ptr2;

	rsize_t max1 = sizeof(str1);
	rsize_t max2 = sizeof(str2);

	t = strtok_s(str1, &max1, "?", &ptr1);
	assert(t != NULL && strcmp("a", t) == 0);

	t = strtok_s(NULL, &max1, ",", &ptr1);
	assert(t != NULL && strcmp("??b", t) == 0);

	t = strtok_s(str2, &max2, " \t", &ptr2);
	assert(t == NULL);

	t = strtok_s(NULL, &max1, "#,", &ptr1);
	assert(t != NULL && strcmp("c", t) == 0);

	t = strtok_s(NULL, &max1, "?", &ptr1);
	assert(t == NULL);
}

int
main(void)
{
	test_n1135();
	return 0;
}
